import { ExecutionContext } from './ExecutionContext';
import { StateContext } from './StateContext';
import { StateMachineContext } from './StateMachineContext';
import { TaskContext } from './TaskContext';
export declare class Context {
    private readonly _executionContext;
    private readonly _stateMachineContext;
    private _stateContext;
    private _taskContext;
    constructor(_executionContext: ExecutionContext, _stateMachineContext: StateMachineContext, _stateContext: StateContext, _taskContext: TaskContext);
    static create(executionContext: ExecutionContext, stateMachineContext: StateMachineContext, stateContext: StateContext, taskContext?: TaskContext): Context;
    get Execution(): ExecutionContext;
    get StateMachine(): StateMachineContext;
    get State(): StateContext;
    get Task(): TaskContext;
    clone(): Context;
    transitionTo(state: StateContext, task?: TaskContext): void;
}
