"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParameterPayloadTemplate = void 0;
const jsonpath_plus_1 = require("jsonpath-plus");
const PayloadTemplate_1 = require("./PayloadTemplate");
class ParameterPayloadTemplate extends PayloadTemplate_1.PayloadTemplate {
    constructor(_payload) {
        super();
        this._payload = _payload;
    }
    static create(payload) {
        return new ParameterPayloadTemplate(payload);
    }
    processPathKey(key, value, inputJson) {
        if (typeof value !== 'string') {
            throw new Error(`The value for the field '${key}' must be a STRING that contains a JSONPath but was an ${typeof value}`);
        }
        const newKey = key.substring(0, key.length - 2);
        const result = jsonpath_plus_1.JSONPath({
            path: value === undefined ? '$' : value,
            json: JSON.parse(inputJson),
        });
        return { [newKey]: result[0] };
    }
    process(inputJson) {
        return this.processPayloadTemplate(inputJson, this._payload);
    }
}
exports.ParameterPayloadTemplate = ParameterPayloadTemplate;
ParameterPayloadTemplate.acceptableParameterProperties = ['FunctionName', 'Payload'];
